#! /usr/bin/python
# Author(s): Keeguon
import pygtk
pygtk.require('2.0')

import os
import gtk

# Variables
page = 'home'

# Checking if go-compiz.py is already installed
app_is_installed = []
apps = 'go-compiz.py'

if os.system("which " + apps) == 0:
		app_is_installed.append(apps)
	
def installed(app):
	global app_is_installed
	return app in app_is_installed

# Defining functions
def cancel_button_activate(widget):
	gtk.main_quit()

def next_button_activate(widget):
	global page
	if installed('go-compiz.py') and page == 'home':
		page = 'gocompiz'
		content_text.set_label(
		'<big><b>Go-Compiz Tray Icon Installer</b></big>\n\n'
		'It seems that you have previously installed Go-Compiz Tray Icon.\n'
		'What do you want to do now:\n\n'
		)
		gocompiz_remove.set_child_visible(True)
		gocompiz_update.set_child_visible(True)
		gocompiz_nothing.set_child_visible(True)
		next_button.connect("clicked", compizinstalled_activate, gocompiz_remove)			
	if page == 'home':
		page = 'select'
		content_text.set_label(
		'<big><b>Go-Compiz Tray Icon Installer</b></big>\n\n'
		'Please select your Compiz launcher command below (commonly\n'
		'compiz if you use GIT or a compiled version, compiz.real on\n'
		'Ubuntu Feisty if you use Compiz with the repositories):\n\n'
		)
		compiz_start.set_child_visible(True)
		compizreal_start.set_child_visible(True)
		next_button.connect("clicked", compizscript_activate, compiz_start)

def compizinstalled_activate(widget, gocompiz_data):
	global page
	global compiz_start
	global compizreal_start
	if page == 'gocompiz':
		gocompiz_group = gocompiz_data.get_group()
		for gocompiz_selection in gocompiz_group:
			if gocompiz_selection.get_active():
				gocompiz_label = gocompiz_selection.get_label()
				break
	
		if gocompiz_label == 'Remove':
			os.system('gksudo -- rm -R /usr/share/go-compiz')
			os.system('gksudo -- rm -R /usr/share/go-compiz_compiz')
			os.system('gksudo -- rm -R /usr/share/go-compiz_compiz.real')
			os.system('gksudo -- rm /usr/bin/go-compiz.py')
			content_text.set_label(
			'<big><b>Go-Compiz Tray Icon Installer</b></big>\n\n'
			'You have successfully removed the Go-Compiz Tray Icon.\n\n'
			'Click on Exit to quit now.'
			)
			gocompiz_remove.set_child_visible(False)
			gocompiz_update.set_child_visible(False)
			gocompiz_nothing.set_child_visible(False)
			cancel_button.set_child_visible(False)
			next_button.set_label(' _Exit')
			next_image.set_from_stock(gtk.STOCK_QUIT, gtk.ICON_SIZE_BUTTON)
			next_button.connect("clicked", gtk.main_quit)
		if gocompiz_label == 'Update':
			page = 'update'
			os.system('gksudo -- rm -R /usr/share/go-compiz')
			os.system('gksudo -- rm -R /usr/share/go-compiz_compiz')
			os.system('gksudo -- rm -R /usr/share/go-compiz_compiz.real')
			os.system('gksudo -- rm /usr/bin/go-compiz.py')
			content_text.set_label(
			'<big><b>Go-Compiz Tray Icon Installer</b></big>\n\n'
			'Please select your Compiz launcher command below (commonly\n'
			'compiz if you use GIT or a compiled version, compiz.real on\n'
			'Ubuntu Feisty if you use Compiz with the repositories):\n\n'
			)
			gocompiz_remove.set_child_visible(False)
			gocompiz_update.set_child_visible(False)
			gocompiz_nothing.set_child_visible(False)
			compiz_start.set_child_visible(True)
			compizreal_start.set_child_visible(True)
			next_button.connect("clicked", compizscript_activate, compiz_start)
		if gocompiz_label == 'Do Nothing':
			content_text.set_label(
			'<big><b>Go-Compiz Tray Icon Installer</b></big>\n\n'
			'You have chose to keep your actual version of Go-Compiz Tray\n'
			'Icon.\n\n'
			'Click on Exit to quit now.'
			)
			gocompiz_remove.set_child_visible(False)
			gocompiz_update.set_child_visible(False)
			gocompiz_nothing.set_child_visible(False)
			cancel_button.set_child_visible(False)
			next_button.set_label(' _Exit')
			next_image.set_from_stock(gtk.STOCK_QUIT, gtk.ICON_SIZE_BUTTON)
			next_button.connect("clicked", gtk.main_quit)

def compizscript_activate(widget, compizscript_data):
	global page
	global compiz_start
	global compizreal_start
	compizscript_group = compizscript_data.get_group()
	for compizscript_selection in compizscript_group:
		if compizscript_selection.get_active():
			compizscript_label = compizscript_selection.get_label()
			break

	if compizscript_label == 'compiz':
		os.system('gksudo -- cp -r ./go-compiz_compiz/ /usr/share/')
		os.system('gksudo -- cp -r -f ./pixmaps/* /usr/share/pixmaps/')
		os.system('gksudo -- chmod a+x /usr/share/go-compiz_compiz/go-compiz.py')
		os.system('gksudo -- ln -s /usr/share/go-compiz_compiz/go-compiz.py /usr/bin/')
		content_text.set_label(
		'<big><b>Go-Compiz Tray Icon Installer</b></big>\n\n'
		'You have successfully installed the Go-Compiz Tray Icon,\n'
		'with compiz as a launcher command.\n\n'
		'If you want to start the Go-Compiz Tray Icon at startup\n'
		'go to Menu>System>Preferences>Sessions and create a new\n'
		'entry with the command go-compiz.py.\n\n'
		'Click on Exit to quit now.'
		)
		gocompiz_remove.set_child_visible(False)
		gocompiz_update.set_child_visible(False)
		gocompiz_nothing.set_child_visible(False)
		compiz_start.set_child_visible(False)
		compizreal_start.set_child_visible(False)
		cancel_button.set_child_visible(False)
		next_button.set_label(' _Exit')
		next_image.set_from_stock(gtk.STOCK_QUIT, gtk.ICON_SIZE_BUTTON)
		next_button.connect("clicked", gtk.main_quit)
	if compizscript_label == 'compiz.real':
		os.system('gksudo -- cp -r ./go-compiz_compiz.real/ /usr/share/')
		os.system('gksudo -- cp -r -f ./pixmaps/* /usr/share/pixmaps/')
		os.system('gksudo -- chmod a+x /usr/share/go-compiz_compiz.real/go-compiz.py')
		os.system('gksudo -- ln -s /usr/share/go-compiz_compiz.real/go-compiz.py /usr/bin/')
		content_text.set_label(
		'<big><b>Go-Compiz Tray Icon Installer</b></big>\n\n'
		'You have successfully installed the Go-Compiz Tray Icon,\n'
		'with compiz.real as a launcher command.\n\n'
		'If you want to start the Go-Compiz Tray Icon at startup\n'
		'go to Menu>System>Preferences>Sessions and create a new\n'
		'entry with the command go-compiz.py.\n\n'
		'Click on Exit to quit now.'
		)
		gocompiz_remove.set_child_visible(False)
		gocompiz_update.set_child_visible(False)
		gocompiz_nothing.set_child_visible(False)
		compiz_start.set_child_visible(False)
		compizreal_start.set_child_visible(False)
		cancel_button.set_child_visible(False)
		next_button.set_label(' _Exit')
		next_image.set_from_stock(gtk.STOCK_QUIT, gtk.ICON_SIZE_BUTTON)
		next_button.connect("clicked", gtk.main_quit)


# Window parameter (start)
installer_window = gtk.Window(type=gtk.WINDOW_TOPLEVEL)
installer_window.set_title('Setup - Go-Compiz Tray Icon')
installer_window.set_default_size(700, 352)
installer_window.set_position(gtk.WIN_POS_CENTER)
installer_window.connect("destroy", gtk.main_quit)

# Separators
vs = gtk.VSeparator()
hs = gtk.HSeparator()

# Creating a Vbox
vbox = gtk.VBox(False, 0)
installer_window.add(vbox)

# Window content
# Creating an Hbox for the image and the text
hbox_top = gtk.HBox(False, 0)

# Compiz Skyscraper
compiz_skyscraper = gtk.Image()
compiz_skyscraper.set_from_file('./img/compiz_skyscraper.png')
# VBox for content
vbox_content = gtk.VBox()
# Content text
content_text = gtk.Label(
'<big><b>Welcome to the Go-Compiz Tray Icon Installer</b></big>\n\n'
'This will install the Go-Compiz Tray Icon on your Computer.\n\n'
'It is recommended that you stop any Compiz or Go-Compiz Tray\n'
'Icon instances before continuing.\n\n'
'Click Next to continue, or Cancel to exit Setup.'
)
content_text.set_use_markup(True)
content_text.set_alignment(0, 0.025)
# Content compiz/compiz.real selector
gocompiz_remove = gtk.RadioButton(label='Remove')
gocompiz_remove.set_child_visible(False)
gocompiz_update = gtk.RadioButton(label='Update')
gocompiz_update.set_child_visible(False)
gocompiz_update.set_group(gocompiz_remove)
gocompiz_nothing = gtk.RadioButton(label='Do Nothing')
gocompiz_nothing.set_child_visible(False)
gocompiz_nothing.set_group(gocompiz_remove)
# Content compiz/compiz.real selector
compiz_start = gtk.RadioButton(label='compiz')
compiz_start.set_child_visible(False)
compizreal_start = gtk.RadioButton(label='compiz.real')
compizreal_start.set_child_visible(False)
compizreal_start.set_group(compiz_start)
# Appending content to vbox_content
vbox_content.pack_start(content_text, False, True, 3)
vbox_content.pack_start(gocompiz_remove, False, True, 3)
vbox_content.pack_start(gocompiz_update, False, True, 3)
vbox_content.pack_start(gocompiz_nothing, False, True, 3)
vbox_content.pack_start(compiz_start, False, True, 3)
vbox_content.pack_start(compizreal_start, False, True, 3)

# Appending elements to the hbox_top
hbox_top.pack_start(compiz_skyscraper, False, True, 3)
hbox_top.pack_start(vs, False, True, 3)
hbox_top.pack_start(vbox_content, False, True, 3)

# Creating an Hbox for the buttons
hbox_bottom = gtk.HBox(False, 0)

# Buttons
cancel_button = gtk.Button(stock=gtk.STOCK_CANCEL)
cancel_button.connect("clicked", cancel_button_activate)
cancel_alignment = gtk.Alignment(1, 0, 0, 0)
cancel_alignment.add(cancel_button)
next_button = gtk.Button(' _Next', use_underline=True)
next_button.connect("clicked", next_button_activate)
next_image = gtk.Image()
next_image.set_from_stock(gtk.STOCK_GO_FORWARD, gtk.ICON_SIZE_BUTTON)
next_button.set_image(next_image)
next_alignment = gtk.Alignment(1, 0, 0, 0)
next_alignment.add(next_button)

# Appending buttons to the hbox_bottom
hbox_bottom.pack_start(cancel_alignment, False, True, 3)
hbox_bottom.pack_start(next_alignment, True, True, 3)

# Appending the content to the vbox
vbox.pack_start(hbox_top, False, True, 3)
vbox.pack_start(hs, False, True, 3)
vbox.pack_start(hbox_bottom, False, True, 3)


installer_window.show_all()
gtk.main()
